import pygame
import pygame.locals as l
import random
import math
def out(text):
    f = open("logfile.txt","w")
    f.write(text)
    f.close()
screen = pygame.display.set_mode([640,480],l.HWSURFACE|l.DOUBLEBUF)
pygame.display.set_caption("Embers")
pygame.display.set_icon(pygame.image.load("data/icon.tga"))

#import psyco
#psyco.full()

import sys
out("17hello!")

class ob(object):
    def __get__(self,attr):
        return object.__getattribute__(self,attr)
        
out("ob")
        
circle = pygame.Surface([screen.get_width(),screen.get_width()]).convert()
pygame.draw.circle(circle,[255,0,255],[screen.get_width()/2,screen.get_width()/2],screen.get_width()/2)
circle.set_colorkey([0,0,0])

out("29circle")

class lightsource(ob):
    def __init__(self,pos,radi):
        self.pos = pos
        self.radi = radi
        self.expand = 0.0
        self.expanddir = 1
    def __getattr__(self,attr):
        if attr=="rect":
            return pygame.Rect([-3,-3,1,1])
        return ob.__get__(self,attr)
    def update(self,dt):
        if self.expand <= 3.0 and self.expand >= -3.0:
            self.expand += self.expanddir
        else:
            self.expanddir = -self.expanddir
            if self.expand >3.0:
                self.expand = 2.9
            if self.expand < -3.0:
                self.expand = -2.9
        radi = self.radi + 5
        dia = radi*2
        dirtyrects.append([int(self.pos[0]-radi),int(self.pos[1]-radi),int(dia),int(dia)])
    def getradi(self):
        return int(self.radi + self.expand)
    def blit(self,dest):
        radi = self.getradi()
        if radi>0:
            #self.surf.fill([0,0,0])
            #center = self.surf.get_width()/2,self.surf.get_height()/2
            scaled = pygame.transform.scale(circle,[radi*2,radi*2])
            #pygame.draw.circle(self.surf,[255,0,255],center,radi)
            #pygame.draw.polygon(self.surf,[255,0,255],
            #[[center[0]-radi,center[1]],[center[0]-radi/2,center[1]-radi],[center[0]+radi/2,center[1]-radi],[center[0]+radi,center[1]],
            #[center[0]+radi/2,center[1]+radi],[center[0]-radi/2,center[1]+radi],[center[0]-radi,center[1]]])
            dest.blit(scaled,[self.pos[0]-scaled.get_width()/2,self.pos[1]-scaled.get_height()/2])

out("67lightsource")

firepic = pygame.image.load("data/fire.png")
fires = {"yellow":firepic.subsurface([2,8,46,56]),"orange":firepic.subsurface([60,2,44,60]),"red":firepic.subsurface([111,8,42,54])}

out("72fires")

class firepiece(ob):
    def __init__(self,color,pos,size):
        self.offset = [0,0]
        self.basesurf = fires[color]
        self.surf = self.basesurf.convert()
        self.size = float(size)#Amount of size difference to radius
        self.velocity = [0,0]
        self.r0 = random.random()
        self.r1 = random.random()
        self.acceleration = [random.choice([-self.r0,self.r0]),random.choice([-self.r0,self.r0])]
        self.pos = pos
    def scale(self,radi):
        self.surf = pygame.transform.scale(self.basesurf,[int((radi+3.0)/self.size),int((radi+3.0)/self.size)])
        self.surf.set_colorkey([255,255,255])
    def update(self,dt,newradi):
        self.scale(newradi)
        dif = self.offset[:]
        if dif[0]:
            self.acceleration[0] = -self.r0*abs(dif[0])/dif[0]
        if dif[1]:
            self.acceleration[1] = -self.r1*abs(dif[1])/dif[1]
        self.velocity[0]+=self.acceleration[0]
        self.velocity[1]+=self.acceleration[1]
        max = .3
        if self.velocity[0]>max:
            self.velocity[0]=max
        if self.velocity[0]<-max:
            self.velocity[0]=-max
        if self.velocity[1]>max:
            self.velocity[1]=max
        if self.velocity[1]<-max:
            self.velocity[1]=-max
        self.offset[0]+=self.velocity[0]
        self.offset[1]+=self.velocity[1]
    def blit(self,dest):
        dest.blit(self.surf,[self.pos[0]-self.surf.get_width()/2+self.offset[0],self.pos[1]-self.surf.get_height()/2+self.offset[0]])
    def get_height(self):
        return self.surf.get_height()
    def get_width(self):
        return self.surf.get_width()
        
out("115firepiece")
        
class fire(lightsource):
    def __init__(self,*args):
        lightsource.__init__(self,*args)
        self.redsource = pygame.Surface([10,10]).convert()
        self.colors = []
        self.colors.append(firepiece("yellow",self.pos,2))
        self.colors.append(firepiece("orange",self.pos,2.2))
        self.colors.append(firepiece("red",self.pos,3))
    def __getattr__(self,attr):
        if attr=="rect":
            return pygame.Rect([int(self.pos[0]-self.colors[0].get_width()/2),int(self.pos[1]-self.colors[0].get_height()/2),self.colors[0].get_width(),self.colors[0].get_height()])
        return lightsource.__getattr__(self,attr)
    def blitcolors(self,dest):
        for fire in self.colors:
            fire.blit(dest)
    def blit(self,dest):
        lightsource.blit(self,dest)
    def update(self,dt):
        self.radi -= .1
        lightsource.update(self,dt)
        for c in self.colors:
            c.update(dt,self.radi)
        wi,hi = self.colors[0].get_width(),self.colors[0].get_height()
        dirtyrects.append([int(self.pos[0]),int(self.pos[1]),int(wi),int(hi)])
        
out("142fire")

treeimage = pygame.image.load("data/trees.png")
treeimage.set_colorkey([255,255,255])
treesurf = treeimage.subsurface([244,186,80,85])
stumpsurf = treeimage.subsurface([396,196,62,54])

out("149trees")

mensimage = pygame.image.load("data/mens.png")
mensimage.set_colorkey([255,255,255])
mansurf = mensimage.subsurface([231,146,54,39])
monsurf = mensimage.subsurface([300,144,68,33])

out("156mens")

class tree(ob):
    def __init__(self,pos):
        self.pos = pos[:]
        self.lastpos = self.pos[:]
        self.state = "tree"
    def blit(self,dest,rec=None):
        if self.state == "tree":
            img = treesurf
        elif self.state == "stump":
            img = stumpsurf
        dest.blit(img,[self.pos[0]-img.get_width()/2,self.pos[1]-img.get_height()/2])
    def update(self,dt):
        #~ if self.lastpos[0]!=self.pos[0] or self.lastpos[1]!=self.pos[1]:
            #~ self.lastpos = self.pos[:]
        dirtyrects.append([int(self.pos[0]-treesurf.get_width()/2),int(self.pos[1]-treesurf.get_height()/2),int(treesurf.get_width()),int(treesurf.get_height())])
    def __getattr__(self,attr):
        if attr=="rect":
            return pygame.Rect([int(self.pos[0]-treesurf.get_width()/2),int(self.pos[1]-treesurf.get_height()),treesurf.get_width(),treesurf.get_height()])
        return ob.__get__(self,attr)
    def __hasattr__(self,attr):
        if attr=="rect":
            return True
        return ob.__hasattr__(self,attr)
        
out("182tree")
        
class man(ob):
    def __init__(self,pos,dir=0,image=mansurf):
        self.pos = pos
        self.dir = dir
        self.lastdir = dir
        self.image = image
        self.rotsurf = pygame.transform.rotate(image,dir)
        self.torch = None
        self.wood = 0
    def __getattr__(self,attr):
        if attr=="rect":
            return pygame.Rect([int(self.pos[0]-self.rotsurf.get_width()/2),int(self.pos[1]-self.rotsurf.get_height()),self.rotsurf.get_width(),self.rotsurf.get_height()])
        return ob.__get__(self,attr)
    def moveforward(self,amount):
        val = -(self.dir+90)*(math.pi/180.)
        while val<0:
            val += 2*math.pi
        x = amount*math.cos(val)
        y = amount*math.sin(val)
        self.pos[0] += x
        self.pos[1] += y
    def aimat(self,point,speed=0.2):
        p1 = self.pos[:]
        p2 = point[:]
        dx = p1[0]-p2[0]
        dy = p1[1]-p2[1]
        quad = 1
        if dx>0 and dy>0:
            quad = 4
        if dx>0 and dy<=0:
            quad = 1
        if dx<=0 and dy<=0:
            quad = 2
        if dx<=0 and dy>0:
            quad = 3
        ang = math.atan(float(dy)/float(dx))
        ang = -(ang*(180./math.pi)-90)
        if quad==3 or quad==1:
            ang+=180
        while ang>360:
            ang -= 360
        while ang<0:
            ang += 360
        dang = self.dir-ang
        #print dang
        if dang:
            self.dir+=-int(float(dang)*speed)
    def update(self,dt):
        if self.dir!=self.lastdir:
            self.lastdir = dir
            self.rotsurf = pygame.transform.rotate(self.image,self.dir)
        if self.torch:
            val = -(self.dir+90-50)*(math.pi/180.)
            while val<0:
                val += 2*math.pi
            x = 25*math.cos(val)
            y = 25*math.sin(val)
            self.torch.pos[0],self.torch.pos[1] = [self.pos[0]+x,self.pos[1]+y]
        dirtyrects.append([int(self.pos[0]-self.rotsurf.get_width()/2),int(self.pos[1]-self.rotsurf.get_height()/2),int(self.rotsurf.get_width()),int(self.rotsurf.get_height())])
    def blit(self,dest):
        dest.blit(self.rotsurf,[self.pos[0]-self.rotsurf.get_width()/2,self.pos[1]-self.rotsurf.get_height()/2])

out("246man")

class monster(man):
    def __init__(self,pos,dir,target=None,image=monsurf):
        man.__init__(self,pos,dir,image)
        self.target = target
    def update(self,dt):
        man.update(self,dt)
        if self.target:
            self.aimat(self.target.pos)
        self.moveforward(5)
        
out("258monster")

pygame.font.init()
fo = pygame.font.Font("data/SuperMarioBros.ttf",18)

out("263font")

class goaltext:
    def __init__(self,pos,text,maxsize=18):
        self.begin(pos,text,maxsize)
        self.fo = pygame.font.Font("data/SuperMarioBros.ttf",50)
        self.makesurf()
    def begin(self,pos,text,maxsize=50):
        self.pos = pos
        self.size = 12
        self.text = text
        self.time = 0
        self.kill = 0
        self.maxsize = maxsize
    def makesurf(self):
        hi = self.size
        normaltext = self.fo.render(self.text,0,[255,255,255])
        aspect = float(normaltext.get_width())/float(normaltext.get_height())
        wi = int(aspect*float(hi))
        scaledtext = pygame.transform.scale(normaltext,[wi,hi])
        self.surf = scaledtext
    def update(self,dt):
        done = 0
        if self.size<self.maxsize:
            self.size += 1
            done +=1
        if self.pos[0]<20:
            self.pos[0]+=1
            done+=1
        if self.pos[1]<200:
            self.pos[1]+=10
            done+=1
        if done==0:
            self.time += 1*dt
            if self.time > 3:
                if self.pos[1]<screen.get_height():
                    self.pos[1]+=10
                else:
                    self.kill = 1
        self.makesurf()
        if self.kill:
            if hasattr(self,"losing"):
                return "die"
            if hasattr(self,"winning"):
                return "win"

darklayer = screen.convert()
darklayer.set_alpha(230)
darklayer.set_colorkey([255,0,255])
dirtyrects = [[0,0,screen.get_width(),screen.get_height()]]

clock = pygame.time.Clock()

class blah:
    def setup1(self,goal="Cut down all 10 trees before your fire dies!"):
        self.man = man([200,300],10)
        self.torch = fire([40,40],50)
        self.man.torch = self.torch
        self.lis = [fire([screen.get_width()/2,screen.get_height()/2],100),self.torch]
        self.trees = []
        self.mons = [monster([400,20],180,self.man)]
        for i in range(10):
            t = tree([0,0])
            col = 10
            while col>-1:
                t.pos[0] = random.randint(0,screen.get_width())
                t.pos[1] = random.randint(0,screen.get_height())
                col = t.rect.collidelist(self.trees)
                if col==-1:
                    col = t.rect.collidelist(self.lis)
            self.trees.append(t)
        self.back = pygame.image.load("data/grass.png")
        self.fps = 0
        
        self.showgoal = 1
        self.goaltext = goaltext([0,20],goal)
        
        self.counters = {"treescut":0,"treesdeposited":0,"maxradius":0,"secondsplayed":0}
        self.winstate = "treescut==10"
        
        self.lasttime = clock.get_time()
        
    def calcwin(self):
        winstate = self.winstate.replace("treescut","self.counters['treescut']").replace("treesdeposited","self.counters['treesdeposited']").replace("secondsplayed","self.counters['secondsplayed']")
        if eval(winstate):
            return True
        
    def update(self,rectlist,dt):
        
        #sort dirty rects
        rectlist2 = []
        ignore = []
        for rec in rectlist:
            #print rec
            if rec in ignore:
                continue
            ignore.append(rec)
            collisionlist = [rectlist[i] for i in pygame.Rect(rec).collidelistall(rectlist)]
            ignore.extend(collisionlist[:])
            if collisionlist:
                rectlist2.append(pygame.Rect(rec).unionall(collisionlist))
            else:
                rectlist2.append(rec)
        while rectlist:
            del rectlist[0]
        rectlist.extend(rectlist2)
        darklayer.fill([0,0,0])
        
        #lights
        for li in self.lis:
            li.blit(darklayer)
            
        #background
        for rec in rectlist:
            screen.blit(self.back,[rec[0],rec[1]],rec)
            
        #trees
        for t in self.trees:
            if t.rect.collidelist(rectlist)>-1:
                t.blit(screen,rec)
                
        #monsters
        for mon in self.mons:
            mon.blit(screen)
            
        #man
        self.man.blit(screen)
        
        #fires
        for li in self.lis:
            li.blitcolors(screen)
            
        #shading
        for rec in rectlist[:]:
            screen.blit(darklayer,[rec[0],rec[1]],rec)
            rectlist.remove(rec)
            
        #text
        woodtext = fo.render("Wood:"+str(self.man.wood),0,[255,255,255])
        screen.blit(woodtext,[0,0])
        rectlist.append([0,0,0+woodtext.get_width(),0+woodtext.get_height()])
        fpstext = fo.render("Fps:"+str(int(self.fps)),0,[255,255,255])
        screen.blit(fpstext,[0,18])
        rectlist.append([0,18,0+fpstext.get_width(),18+fpstext.get_height()])
        treescuttext = fo.render("Trees cut:"+str(self.counters["treescut"]),0,[255,255,255])
        screen.blit(treescuttext,[0,36])
        rectlist.append([0,63,0+treescuttext.get_width(),36+treescuttext.get_height()])
        secondsplayedtext = fo.render("Secondsplayed:"+str(int(self.counters["secondsplayed"])),0,[255,255,255])
        screen.blit(secondsplayedtext,[0,54])
        rectlist.append([0,54,0+secondsplayedtext.get_width(),54+secondsplayedtext.get_height()])
        
        if self.showgoal and not self.goaltext.kill:
            screen.blit(self.goaltext.surf,self.goaltext.pos)
            response = self.goaltext.update(dt)
            if response == "die":
                return "die"
            elif response == "win":
                return "win"
            dirtyrects.append([self.goaltext.pos[0]-5,self.goaltext.pos[1]-10,self.goaltext.surf.get_width()+10,self.goaltext.surf.get_height()+20])
        #screen.blit(darklayer,[0,0])
    
    def loop(self):
        keys = pygame.key.get_pressed()
        while not keys[l.K_ESCAPE]:
            
            clock.tick(60)
            self.fps = clock.get_fps()
            
            dt = 0
            if self.fps:
                dt = (1.0/self.fps)
            
            self.counters["secondsplayed"]+=dt
            
            pygame.event.pump()
            keys = pygame.key.get_pressed()
            for li in self.lis:
                li.update(dt)
                if li.radi<=0:
                    self.lis.remove(li)
            for tr in self.trees:
                tr.update(dt)
            for mon in self.mons:
                mon.update(dt)
            self.man.update(dt)
            pygame.display.flip()
            if keys[l.K_RIGHT]:
                self.man.dir -= 5
            if keys[l.K_LEFT]:
                self.man.dir += 5
            if keys[l.K_UP]:
                self.man.moveforward(3)
            if keys[l.K_SPACE]:
                trees = self.man.rect.collidelistall(self.trees)
                for t in trees:
                    tree = self.trees[t]
                    if tree.state == "tree":
                        tree.state = "stump"
                        self.man.wood += 1
                        self.counters["treescut"]+=1
            lights = self.man.rect.collidelistall(self.lis)
            if self.torch in self.lis and self.lis.index(self.torch) in lights:
                lights.remove(self.lis.index(self.torch))
            if lights:
                li = self.lis[lights[0]]
                if self.man.wood>0:
                    self.man.wood -= 1
                    li.radi += 20
                    self.counters["treesdeposited"]+=1
                if li.radi>=5:
                    if self.torch.radi<50:
                        self.torch.radi = 50
            if not self.lis and self.goaltext.text!="The darkness closes in!!!":
                self.goaltext.begin([0,0],"The darkness closes in!!!")
                print "lose"
                self.goaltext.losing = 1
            
            #self.update(dirtyrects,dt)
            response = self.update([[0,0,screen.get_width(),screen.get_height()]],dt)
            if response == "die" or response == "win":
                return
            
            if self.calcwin() and self.goaltext.text!="You win this level!":
                self.goaltext.begin([0,0],"You win this level!")
                self.goaltext.winning = 1
                print "you win!"

out("begin")
g = blah()
out("setup")
g.setup1()
out("loop")
g.loop()
